#line 1 "C:/Users/Ng Yong Han/Documents/pic_projects2012/pic16f1503-IRtrans1/pic16f1503-IRtrans1.c"
unsigned char i;
unsigned char sendBit[7];
unsigned char address[] = {1,0,0,0,0};
unsigned char button_status = 0;

void interrupt() iv 0x0004 ics ICS_AUTO
{
 if(INTCON.INTF == 1)
 {
 button_status = 1;
 INTCON.INTF = 0;
 }
}

void init()
{
 OSCCON.IRCF3 = 1;
 OSCCON.IRCF2 = 1;
 OSCCON.IRCF1 = 0;
 OSCCON.IRCF0 = 1;
 OSCCON.SCS0 = 0;
 OSCCON.SCS1 = 0;

 PORTA = 0x00;
 PORTC = 0x00;
 TRISA = 0x00;
 TRISC = 0x00;
 CM1CON0 = 0x00;
 CM2CON0 = 0x00;
 ANSELA = 0x00;
 ANSELC = 0x00;
 WPUA = 0x00;
 VREGCON.VREGPM = 1;

 TRISA.TRISA2 = 1;
}

void init_pwm()
{
 TRISC.TRISC5 = 1;

 OSCCON.IRCF3 = 1;
 OSCCON.IRCF2 = 1;
 OSCCON.IRCF1 = 0;
 OSCCON.IRCF0 = 1;
 OSCCON.SCS0 = 0;
 OSCCON.SCS1 = 0;

 PWM1CON = 0x00;
 PWM2CON = 0x00;
 PWM3CON = 0x00;
 PWM4CON = 0x00;

 PR2 = 25-1;
 T2CON = 0x00;
 T2CON.TMR2ON = 1;
 PIR1.TMR2IF = 0;
 PIE1.TMR2IE = 0;

 PWM1CON.PWM1OE = 1;
 PWM2CON.PWM2OE = 0;
 PWM3CON.PWM3OE = 0;
 PWM4CON.PWM4OE = 0;

 PWM1CON.PWM1EN = 1;
 PWM2CON.PWM2EN = 0;
 PWM3CON.PWM3EN = 0;
 PWM4CON.PWM4EN = 0;

 PWM1DCH = 0b00000110;
 PWM1DCL = 0b01000000;

 TRISC.TRISC5 = 0;
}

void disable_pwm()
{
 PWM1CON = 0x00;
 PIR1.TMR2IF = 0;
 PIE1.TMR2IE = 0;
 T2CON.TMR2ON = 0;
 PWM1CON.PWM1OE = 0;
 PWM1CON.PWM1EN = 0;
}

void enable_interrupt()
{
 INTCON.GIE = 1;
 INTCON.INTF = 0;
 INTCON.INTE = 1;
 INTCON.INTEDG = 0;
 INTCON.IOCIE = 0;
}

void disable_interrupt()
{
 INTCON.GIE = 0;
}

void IR_send(unsigned char commandByte)
{
 for(i = 0; i < 7; i++) {
 sendBit[i] = (commandByte >> i) & 0x01;
 }

 PWM1CON.PWM1OE = 1;

 delay_us(2400);
 PWM1CON.PWM1OE = 0;

 delay_us(600);

 for(i = 0; i < 7; i++) {

 if(sendBit[i] == 1) {
 PWM1CON.PWM1OE = 1;

 delay_us(1200);
 PWM1CON.PWM1OE = 0;

 delay_us(600);
 }
 else {
 PWM1CON.PWM1OE = 1;

 delay_us(600);
 PWM1CON.PWM1OE = 0;

 delay_us(600);
 }
 }

 for(i = 0; i < 5; i++) {

 if(address[i] == 1) {
 PWM1CON.PWM1OE = 1;

 delay_us(1200);
 PWM1CON.PWM1OE = 0;

 delay_us(600);
 }
 else {
 PWM1CON.PWM1OE = 1;

 delay_us(600);
 PWM1CON.PWM1OE = 0;

 delay_us(600);
 }
 }

}

void sleep()
{
 OSCCON.IRCF3 = 0;
 OSCCON.IRCF2 = 0;
 OSCCON.IRCF1 = 0;
 OSCCON.IRCF0 = 0;
 OSCCON.SCS0 = 0;
 OSCCON.SCS1 = 0;
 asm sleep
 delay_us(250);
}

void main()
{
 init();
 enable_interrupt();
 init_pwm();
 PWM1CON.PWM1OE = 1;

 while(1)
 {
 if(button_status == 1)
 {
 init_pwm();
 IR_send(0x14);
 delay_ms(45);
 IR_send(0x14);
 delay_ms(45);
 IR_send(0x14);
 delay_ms(45);
 disable_pwm();
 button_status = 0;
 }
 sleep();
 }
}
